Bug 210557 - Back port of Kprobes deadlock fixes
Back port of Kprobes deadlock fixes
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.4
All Linux
medium Severity medium
: ---
: ---
Assigned To: Luming Yu
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-10-12 16:33 EDT by Anil S Keshavamurthy
Modified: 2013-08-05 21:42 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-03-21 05:26:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Anil S Keshavamurthy 2006-10-12 16:33:11 EDT
Description of problem:

The following two patches which made it into 2.6.19-rc1 needs to be back ported
to RHEL4. This patch fixes the kretprobe spinlock deadlock and deadlock when
probed on notifier_call_chain.

-----------------------------------------------
commit 99219a3fbc2dcf2eaa954f7b2ac27299fd7894cd
Author: bibo,mao <bibo.mao@intel.com>
Date:   Mon Oct 2 02:17:35 2006 -0700

    [PATCH] kretprobe spinlock deadlock patch
http://kernel.org/git/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=99219a3fbc2dcf2eaa954f7b2ac27299fd7894cd
    
    kprobe_flush_task() possibly calls kfree function during holding
    kretprobe_lock spinlock, if kfree function is probed by kretprobe that will
    incur spinlock deadlock.  This patch moves kfree function out scope of
    kretprobe_lock.
    
    Signed-off-by: bibo, mao <bibo.mao@intel.com>
    Signed-off-by: Ananth N Mavinakayanahalli <ananth@in.ibm.com>
    Signed-off-by: Andrew Morton <akpm@osdl.org>
    Signed-off-by: Linus Torvalds <torvalds@osdl.org>

commit f2aa85a0ccd90110e76c6375535adc3ae358f971
Author: bibo,mao <bibo.mao@intel.com>
Date:   Mon Oct 2 02:17:34 2006 -0700

    [PATCH] disallow kprobes on notifier_call_chain
http://kernel.org/git/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=f2aa85a0ccd90110e76c6375535adc3ae358f971
    
    When kprobe is re-entered, the re-entered kprobe kernel path will will call
    atomic_notifier_call_chain function, if this function is kprobed that will
    incur numerous kprobe recursive fault.  This patch disallows kprobes on
    atomic_notifier_call_chain function.
    
    Signed-off-by: bibo, mao <bibo.mao@intel.com>
    Signed-off-by: Ananth N Mavinakayanahalli <ananth@in.ibm.com>
    Signed-off-by: Andrew Morton <akpm@osdl.org>
    Signed-off-by: Linus Torvalds <torvalds@osdl.org>

Version-Release number of selected component (if applicable):
RHEL4U4.
Comment 1 Keve Gabbert 2007-03-16 15:29:33 EDT
did this get into RHEL 4.5?
Comment 4 Luming Yu 2007-03-21 05:22:26 EDT
Anil said "this is not a critical patch as Systemtap now blacklists functions on
which probles causes deadlocks.
Comment 5 Luming Yu 2007-03-21 05:26:17 EDT
And the blacklists functions sounds like a reasonable solution for this kind of
problem. Mark it resolved and WONNT FIX.

Note You need to log in before you can comment on or make changes to this bug.